
# Print some information
# Example: yourfile.hsp?hspinfo_env (prints content of %ENV to the screen)

package HSPInfo;

sub hspinfo_out{
	my $key = lc shift;
	my $sub;
	if($key eq 'env' || $key eq 'ENV'){
		$sub = \&print_env;
	}elsif($key eq 'code'){
		$sub = \&print_code;
	}
	if($sub){
		HSP::request_sendheader("content-type: text/html");
		out("\n\n");
		out("<html><head>\n");
		out("<title>HSPInfo: \u$key</title>\n");
		out(
		"<style><!--\n"
		. ".hspinfo {border-style: outset; border-width: 2px;}\n"
		. ".hspinfo td {border-style: outset; border-width: 2px;}\n"
		. "--></style>\n"
		);
		out("</head>\n");
		out("<body bgcolor=white link=blue>\n");
		$sub->();
		out("</body></html>");
		exit;
	}
}

sub out{
	HSP::request_print(@_);
}

sub print_env{
	out("<table width=100% border=0 class=hspinfo>\n");
	out("<tr><th><h2>Content of %ENV</h2></th><th>&nbsp;</th></tr>\n");
	out(join '', map {($;=$ENV{$_})=~s/</&lt;/g; "<tr><td>$_</td><td>$;</td></tr>\n"} sort keys %ENV);
	out("</table>");
}

sub print_code{
	my $source = $HSP::form{code};
	my $code = $source;
	$code =~s/&/&amp;/g;
	$code =~s/</&lt;/g;
	my $html = <<EOF;
<style><!--
.block1, .block2 {color:#0000c0;}
.perlsyn {font-family: monospace; font-size:10pt;}
.perlsyn .c1{color:#f00000; font-size:11pt} /*Braces*/
.perlsyn .c2{color:#0000c0} /*Keywords*/
.perlsyn .c3{color:#008080} /*Quotes*/
.perlsyn .c4{color:#008000} /*Comments*/
.nocode {
	background-color:#e0e0e0;
	color:#800080;
	font-family:arial,sans-serif;
	font-weight:normal;
	font-style:italic;
	font-size:9.5pt
} /*HTML Code*/
//--></style>
<form action=$ENV{SCRIPT_NAME}?hspinfo_code method=post>
<table width=100% class=hspinfo>
<tr><td>
<textarea name=code cols=60 rows=10 wrap=off style="width:100%">$code</textarea>
</td></tr>
<tr><td align=center>
<input type=submit>
<span class=nocode>HTML</span>
<span class=perlsyn><span class=c2>Code</span></span>
<span class=perlsyn><span class=c3>String</span></span>
<span class=perlsyn><span class=c4>Comments</span></span>
</td></tr>
</table>
</form>
<!-- HSP Perl Syntax -->
EOF
	my $sourcelength = length $source;
	my @tags = (
	['<~', '~>', index($source, '<~')], # Default
	['<*', '*>', index($source, '<*')], # Problems in s/<\/?\w+[^>]*>// :-(
	['<?', "?>", index($source, '<?')], # PHP Style
	['<%', '%>', index($source, '<%')], # ASP Style
	['<script language="HSP">', '</script>', index($source, '<script language="HSP">')],
	);
	foreach(@tags){
		if($_->[2] < 0){ $_->[2] = $sourcelength }
	}
	@tags = sort {$a->[2] <=> $b->[2]} @tags;
	my $ptag1 = $tags[0]->[0];
	my $ptag2 = $tags[0]->[1];
	my $rtag1 = $ptag1;
	my $rtag2 = $ptag2;
	$rtag1=~s/</&lt;/g;
	$rtag2=~s/</&lt;/g;
	my @blocks;
	$source =~ s|\Q$ptag1\E(.*?)\Q$ptag2\E|
		my $chunk=$1;
		applyperl(\$chunk);
		push @blocks, "</span><b class=block1>$rtag1</b>$chunk<b class=block2>$rtag2</b><span class=nocode>";
		"\01-$#blocks;"
	|esg;
	$source=~s/&/&amp;/g;
	$source=~s/</&lt;/g;
	$source=~s/\01-(\d+);/$blocks[$1]/g;
	$html .= '<pre><span class=nocode>' . $source . '</span></pre>';
	out($html);
}


sub _applyperl_init{
	my %perlsyn = map {($_ => 1)} qw(
bless close closedir cmp die eq eval exit grep local map my open opendir package print
return splice split sub use require warn do each else elsif for foreach if
unless until values while abs alarm and atan2 binmode caller chdir chmod chomp chop
chr cos crypt defined delete eof exec exists exp flock fork format g getc glob gmtime
goto hex import index int join keys last lc lcfirst length local localtime m mkdir ne
new next no not oct or ord pack pipe pop pos printf push q qq quotemeta qw qx rand read
readdir ref
rename reverse rindex rmdir s scalar seek seekdir select shift sin sleep sort splice split
sprintf sqrt srand stat substr syscall sysopen sysread system tell telldir tie time tr
truncate uc ucfirst umask undef unlink unpack unshift untie utime vec wait wantarray
write x xor y);

=no
my %perlsyn = map {($_ => 1)} qw(
bless close closedir cmp die eval exit grep local map my open opendir package print
return splice split sub use require warn
do each else elsif for foreach if unless until values while
a b AUTOLOAD BEGIN CORE DESTROY END STDERR STDIN STDOUT abs accept alarm and atan2 bind
binmode caller chdir chmod chomp chop chown chr chroot cmp connect continue cos crypt
dbmclose dbmopen defined delete dump endgrent endhostent endnetent endprotoent
endpwent endservent eof eq exec exists exp fcntl fileno flock fork format formline
ge getc getgrent getgrgid getgrnam gethostbyaddr gethostbyname gethostent getlogin
getnetbyaddr getnetbyname getnetent getpeername getpgrp getppid getpriority getprotobyname
getprotobynumber getprotoent getpwent getpwnam getpwuid getservbyname getservbyport
getservent getsockname getsockopt glob gmtime goto gt hex import index int ioctl join keys
kill last lc lcfirst le length link listen local localtime log lstat lt m mkdir msgctl
msgget msgrcv msgsnd ne new ne next no not oct or ord pack pipe pop pos printf push q qq
quotemeta qw qx rand read readdir readlink readpipe recv redo ref rename reset reverse
rewinddir rindex rmdir s scalar seek seekdir select semctl semget semop send setgrent
sethostent setnetent setpgrp setpriority setprotoent setpwent setservent setsockopt
shift shmctl shmget shmread shmwrite shutdown sin sleep socket socketpair sort split
sprintf sqrt srand stat study subs substr symlink sysopen syscall sysread system syswrite
tell telldir time times tr truncate uc ucfirst umask undef unlink unpack unshift untie
utime vars vec wait waitpid wantarray write x xor y);
=cut

	my $inited = 1;
	sub applyperl{
	_applyperl_init() unless $inited;
	delete $perlsyn{lt};
	delete $perlsyn{gt};
	delete $perlsyn{amp};
	my $colorize = sub{
		my $str = shift;
		my $class = shift;
		$str=~s/<span class=\w+>//g;
		$str=~s/<\/span>//g;
		return $str if $class eq '';
		$str="<span class=$class>$str</span>";
		return $str;
	};
	my $code = shift;
	for($$code){
		s/\r//g;
		s/&/&amp;/g;
		s/</&lt;/g;
		s/>/&gt;/g;
		s/\\'/<\01:1>/g;
		s/\\"/<\01:2>/g;
		s/({|})/$colorize->($1,'c1')/eg;
		s/(\w+)/$perlsyn{$1}?$colorize->($1,'c2'):$1/eg;
		# Do not use keywords before this line
		s/(\$<.*?>\w+<.*?>)/$colorize->($1,'')/eg;
		s/(\%<.*?>\w+<.*?>)/$colorize->($1,'')/eg;
		s/(\@<.*?>\w+<.*?>)/$colorize->($1,'')/eg;
		s/(".*?(?:"|$))/'<qq>'.$colorize->($1,'c3').'<_qq>'/meg;
		s/('.*?(?:'|$))/'<qq>'.$colorize->($1,'c3').'<_qq>'/meg;
	}
	my @lines = split /\n/, $$code;
	my @syntax;
	foreach(@lines){
		my @qu = (1);
		push @qu, $1 while s/<qq>(.*?)<_qq>/<\01qu$#qu>/;
		s/(^|[\{\}]<\/span>|[^a-zA-Z\$\#\>\\])(#)(.*)/$1<comment>$2$3/g;
		# C/Java/Javascript/PHP style
		#s/(^|[\{\}]<\/span>|[^a-zA-Z\$\#\>\\])(#|\/\/|\/\*)(.*)/$1<comment>$2$3/g;
		s/<\01qu(\d?)>/$qu[$1+1]/g;
		s/<comment>(.*)/$colorize->($1,'c4')/e;
		s/<\01:1>/\\'/g;
		s/<\01:2>/\\"/g;
		push @syntax, $_;
	}
	$$code = "<span class=perlsyn>" . (join "\n", @syntax) . "</span>";
}
}

1;



